# Check if powershell 4.0 or higher is installed
$psversion = $PSVersionTable.PSVersion.Major
if ($psversion -lt 4)
{
    echo "Please install Powershell 4.0 or higher."
    $null = $Host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
    exit
}

# Check if running as administrator
$isAdmin = ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole]::Administrator)

if (-not$isAdmin)
{
    # Relaunch the script as administrator
    Start-Process powershell.exe -ArgumentList "-NoProfile -ExecutionPolicy Bypass -File `"$( $MyInvocation.MyCommand.Definition )`"" -Verb RunAs
    exit
}

echo "----------------------------------------"
echo "Petti Installer"
echo "www.petti.in"
echo "Version 1.0.0"
echo "----------------------------------------"

echo ""
echo "[1] Reverting previous installation..."
# Remove service "PettiWorker"
sc.exe stop PettiWorker > $null
Start-Sleep -Seconds 2
sc.exe delete PettiWorker > $null
Start-Sleep -Seconds 2
echo "Done."

echo ""
echo "[2] Installing..."
$servicePath = $PSScriptRoot + "\PettiWorker.exe"
# Get current logged in user name
$currentUserName = [System.Security.Principal.WindowsIdentity]::GetCurrent().Name
echo ""
echo "Setting up Petti for user: $currentUserName"
$pass = Read-Host 'Please enter your password' -AsSecureString
$pass = [Runtime.InteropServices.Marshal]::PtrToStringAuto(
        [Runtime.InteropServices.Marshal]::SecureStringToBSTR($pass))
# @formatter:off
sc.exe create PettiWorker binPath=$servicePath start=auto obj=$currentUserName password=$pass
$pass = ""
$scA = $?
sc.exe failure PettiWorker reset=0 actions=restart/60000/restart/60000/restart/60000
$scB = $?
# @formatter:on
echo "Done."

if ($scA -and $scB)
{
    echo ""
    echo "[3] Verifying..."
    Start-Sleep -Seconds 2
    sc.exe start PettiWorker
    if ($?)
    {
        Start-Sleep -Seconds 2
        sc.exe stop PettiWorker > $null
        echo "Done."
        echo ""
        echo "Installation complete."
    }
    else
    {
        echo ""
        echo "Failed to verify installation. Please recheck your password and try again. If the problem persists, please contact support."
    }
}
else
{
    echo ""
    echo "Installation failed. Please try again in a minute. If the problem persists, please contact support."
}
echo "----------------------------------------"
echo ""
echo ""
echo "Press any key to close..."
$null = $Host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")